//--------------------------------------------------------------------//
// 3Lvf@(FEM)

var model;		// FEMf[^f
var viewModel;		// \f
var viewObj;		// \IuWFNg
var bounds;		// fE
var info;		// f\
var colorBar;		// J[o[
var resultView;		// ʕ\ݒ
var viewConfig;		// f\ݒ
var modalWindow;	// [_EBhE

var FILE_WINDOW=0;	// t@CEBhE
var CALC_WINDOW=1;	// vZݒEBhE
var RESULT_WINDOW=2;	// ʕ\ݒEBhE
var CONFIG_WINDOW=3;	// RtBOEBhE

// f[^
// fileName - f[^t@C
function initModel(fileName){
  model=new FemDataModel();
  initThree();
  resultView=new ResultView();
  viewConfig=new ViewConfig();
  if((fileName!==null) && (fileName!==undefined)){
    readServerFemFile(fileName);
  }
  modalWindow=[document.getElementById('file'),
      	       document.getElementById('calc'),
      	       document.getElementById('result'),
      	       document.getElementById('config')];
  loop();
}

// three.js ̏
function initThree(){
  document.addEventListener('keydown',keyPressed,false);
  bounds=new Bounds();
  viewModel=new ViewModel('fem-canvas');
  viewObj=new ViewObject();
  info=document.getElementById('info-canvas');
  colorBar=new ColorBar('colorbar');
}

// L[̏s
function keyPressed(e){
  switch(e.keyCode){
    case 88:		// X
      viewModel.viewX();
      break;
    case 89:		// Y
      viewModel.viewY();
      break;
    case 90:		// Z
      viewModel.viewZ();
      break;
  }
}

// \IuWFNg
function initObject(){
  viewObj.remove();
  viewObj.create();
  viewModel.updateLightAndCamera();
  colorBar.clear();
  resultView.setContourSelect();
  showInfo();
}

// [v֐
function loop(){
  viewModel.update();
  requestAnimationFrame(loop);
  viewModel.setAxis();
}

// f\
function showInfo(){
  if(model.result.calculated){
    if((model.result.dispMax===0) && (model.result.tempMax!==0)){
      info.textContent='x Max.:'+numString(model.result.tempMax);
    }
    else{
      info.textContent='ψ Max.:'+numString(model.result.dispMax);
    }
  }
  else{
    info.innerHTML='ߓ_:'+model.mesh.nodes.length+
      	      	   '<br />vf:'+model.mesh.elements.length;
  }
}

// ŗLl\
// index - ŗLl̃CfbNX
// type - ͎
// value - ŗLl
function showEigenValue(index,type,value){
  if(type===BUCKLING){
    info.textContent='ŗLl'+(index+1)+': '+numString(value);
  }
  else{
    info.textContent='ŗLU'+(index+1)+': '+numString(value);
  }
}

// l\Ԃ
// value - l
function numString(value){
  var vabs=Math.abs(value);
  if(vabs>=1.0E5){
    return value.toExponential(4);
  }
  else if((vabs>=1) || (vabs===0)){
    return value.toFixed(3);
  }
  else if(vabs>=0.01){
    return value.toFixed(4);
  }
  else{
    return value.toExponential(4);
  }
}

// [_EBhE\
// win - [_EBhẼCfbNX
function showModalWindow(win){
  modalWindow[win].style.zIndex=4;
  modalWindow[win].style.opacity=1;
}

// [_EBhE\ɂ
// win - [_EBhẼCfbNX
function hideModalWindow(win){
  modalWindow[win].style.zIndex=1;
  modalWindow[win].style.opacity=0;
}

// p֌Wݒ肷
// ctor - VNX
// superCtor - pNX
function inherits(ctor,superCtor){
  if((ctor===undefined) || (ctor===null))
    throw new TypeError('The constructor to `inherits` must not be '+
                        'null or undefined.');

  if((superCtor===undefined) || (superCtor===null))
    throw new TypeError('The super constructor to `inherits` must '+
                        'not be null or undefined.');

  if(superCtor.prototype===undefined)
    throw new TypeError('The super constructor to `inherits` must '+
                        'have a prototype.');
  ctor.super_=superCtor;
  Object.setPrototypeOf(ctor.prototype,superCtor.prototype);
}
